

function create(form)
{
	form.chxbxp1.checked = true;
	form.chxbxm1d.checked = true;

getRomInfo(form);
errorchk(form);

var continuecreation = "TRUE";

if (stop_alertonstart == 0)
{
	if (form.errors.value) {
		if (form.errchk.checked)
			if (!confirm(l_cnferr))
				continuecreation = "FALSE";
	} else if (form.errchk.checked) {
		alert(l_cnfcrt);
	}
}

if (continuecreation == "TRUE")
{


if (form.picker.value == "fba")
{
	var fba_version = form.fba_version.value;

	var prg_num  = "0x10";
	var srm_num  = "1";
	var gfx_num  = "1";
	var mdrm_num = "0x10";
	var snd_num  = "2";
	var sma_num  = "0x10";
	var mrm_num  = "0x10";

	if (fba_version == "new")
	{
		prg_num  = "1 | BRF_ESS | BRF_PRG ";
		srm_num  = "2 | BRF_GRA ";
		gfx_num  = "3 | BRF_GRA ";
		mdrm_num = "4 | BRF_ESS | BRF_PRG ";
		snd_num  = "5 | BRF_SND ";
		sma_num  = "9 | BRF_ESS | BRF_PRG ";
		mrm_num  = "0 | BRF_PRG | BRF_OPT ";
	}

	var beginning_space = "";
	if (fba_version == "new")
		beginning_space = " ";

	var n1 = 0;

	var additional = "";
	if (form.bootleg.checked) additional += " (Bootleg)";
	if (form.proto.checked) additional += " (Prototype)";

	form.fbagen.value ="// " + form.realname.value + additional + "\n\n";
	form.fbagen.value +="static struct BurnRomInfo " + form.setname.value + "RomDesc[] = {\n";

// Px Output

	for (i = 1; i < 4; i++)	{
		if (form["chxbxp" + i].checked)
		{
			form.fbagen.value +="	{" + beginning_space + "\"" + PxInfo[i-1][0] + "\", 0x" + PxInfo[i-1][1] + ", " + fba_hash(PxInfo[i-1][2]) + ", " + prg_num + "}, //  " + n1;
			if (i==1) form.fbagen.value += " 68K Code";
			form.fbagen.value += "\n";

			n1++;
		}
	}

// S1 Output

	if (form.chxbxs1.checked)
	{
		form.fbagen.value +="\n	{" + beginning_space + "\"" +  S1Info[0] + "\", 0x" + S1Info[1] + ", " + fba_hash(S1Info[2]) +  ",    " + srm_num + "},";

		if (fba_version == "new")
			form.fbagen.value += "	      ";
	
		form.fbagen.value += " //  " + n1 + " Text data\n";

		n1++;
	}

// Cx Output

	var c1_label = 0;
	if (getlen("c", 1, 8, 1) > 0) form.fbagen.value += "\n";

	for (var i = 1; i < 9; i++) {
		if (form["chxbxc" + i].checked)
		{
			form.fbagen.value +="	{" + beginning_space + "\"" +  CxInfo[i-1][0] + "\", 0x" + CxInfo[i-1][1] + ", " + fba_hash(CxInfo[i-1][2]) +  ",    " + gfx_num + "},";

			if (fba_version == "new")
				form.fbagen.value += "	      ";

			form.fbagen.value += " //  " + n1;

			if (c1_label == 0) form.fbagen.value += " Sprite data";

			form.fbagen.value += "\n";

			n1++;
			c1_label = 1;
		}
	}

// M1/M1D Output

	if (form.chxbxm1d.checked) {
		form.fbagen.value +="\n	{" + beginning_space + "\"" + M1dInfo[0] + "\", 0x" + M1dInfo[1] + ", " + fba_hash(M1dInfo[2]) +  ", " + mdrm_num + "}, //  " + n1 + " Z80 code";

		if (form.chxbxm1.checked)
			form.fbagen.value += " (decrypted)";

		form.fbagen.value += "\n";

		n1++;
	}

	if (form.chxbxm1.checked)
	{
		form.fbagen.value +="	{" + beginning_space + "\"" + M1Info[0] + "\",  0x" + M1Info[1] + ", " + fba_hash(M1Info[2]) +  ", " + mrm_num + "}, //  " + n1 + " Z80 code\n";
		n1++;
	}

// Vx Output

	var vx_label = 0;
	if (getlen("v", 1, 5, 0) > 0) form.fbagen.value += "\n";

	for (var i = 1; i < 6; i++)
	{
		if (form["chxbxv" + i].checked)
		{
			var name = VxInfo[i-1][0];
			form.fbagen.value +="	{" + beginning_space + "\"" + name + "\", 0x" + VxInfo[i-1][1] + ", " + fba_hash(VxInfo[i-1][2]) +  ",    ";

			if (fba_version == "new")
			{
				if ((name.slice(4,7) == "v21")||(name.slice(4,7) == "v22")||(name.slice(4,7) == "v23")||(name.slice(4,7) == "v24"))
				{
					form.fbagen.value += "6 | BRF_SND ";
				} else {
					form.fbagen.value += snd_num;
				}

				form.fbagen.value += "},		//  " + n1;
			}
			else
				form.fbagen.value += snd_num + "}, //  " + n1;

				if (vx_label == 0) form.fbagen.value += " Sound data";
				form.fbagen.value += "\n";

			n1++;
			vx_label = 1;
		}
	}

// End Rom Output

	form.fbagen.value +="}; \n\nSTDROMPICKEXT(" + form.setname.value + ", " + form.setname.value + ", neogeo); \nSTD_ROM_FN(" + form.setname.value + ");\n";

// Init Output

	var show_fba_init = 0;

	var enable_textromfix = 0;
	if ((form.textromfix.checked) && (form.chxbxs1.checked == "")) enable_textromfix = 1;

	var pulstar_fix = 0;
	if (form.setname.value.toLowerCase() == "pulstar") pulstar_fix = 1;

	if ((pulstar_fix)||((form.GfxKey.value)&&(form.criptsel.value))||(form.pcm2.value!=00)||(enable_textromfix))
	{
		show_fba_init = 1;
	}

	if (show_fba_init)
	{
		form.fbagen.value +="\nstatic int " + form.setname.value + "Init()\n{\n";

		if (form.pcm2.value != "00")
		{
			form.fbagen.value += "	int nRet;\n\n"
		}

		if (pulstar_fix) form.fbagen.value +="	nNeoSRAMProtection = 0x035A;\n"

		if (enable_textromfix)	form.fbagen.value +="	nNeoTextROMSize = 0x080000;\n";

		if ((form.criptsel.value) && (form.GfxKey.value))
		{
			form.fbagen.value +="	nNeoProtectionXor = 0x" + form.GfxKey.value + ";\n";
		}

		if (form.pcm2.value == "00")
		{
			form.fbagen.value +="\n	return NeoInit();\n}\n";
		} else {

			form.fbagen.value += "\n	if (nRet == 0) {\n";

			var pcm2x = new Array(
				new Array( "0x0A5000, 0x000000", "0xF9, 0xE0, 0x5D, 0xF3, 0xEA, 0x92, 0xBE, 0xEF" ),
				new Array( "0x001000, 0xFFCE20", "0xC4, 0x83, 0xA8, 0x5F, 0x21, 0x27, 0x64, 0xAF" ),
				new Array( "0x04E001, 0xFE2CF6", "0xC3, 0xFD, 0x81, 0xAC, 0x6D, 0xE7, 0xBF, 0x9E" ),
				new Array( "0x0C2000, 0xFFAC28", "0xC3, 0xFD, 0x81, 0xAC, 0x6D, 0xE7, 0xBF, 0x9E" ),
				new Array( "0x00A000, 0xFEB2C0", "0xCB, 0x29, 0x7D, 0x43, 0xD2, 0x3A, 0xC2, 0xB4" ),
				new Array( "0x0A7001, 0xFF14EA", "0x4B, 0xA4, 0x63, 0x46, 0xF0, 0x91, 0xEA, 0x62" ),
				new Array( "0x002000, 0xFFB440", "0x4B, 0xA4, 0x63, 0x46, 0xF0, 0x91, 0xEA, 0x62" )
			);

			if (form.pcm2.value >= 11) {
				form.fbagen.value += "		PCM2DecryptVInfo Info = { " + pcm2x[form.pcm2.value-11][0] + ", { " + pcm2x[form.pcm2.value-11][1] + "} };\n\n";
			}

			if (eval(form.pcm2.value) >= 10) form.fbagen.value += "		PCM2DecryptV(&Info);\n"

			if (eval(form.pcm2.value) < 10)
			{
				var pcm2vtot = 0;
				for (i = 1; i < 6; i++)
					if (form["chxbxv" + i].checked) pcm2vtot += eval(form["v" + i + "size"].value);

				var pcm2v1t = (form.pcm2.value<<3);
				if (form.pcm2.value == "03") pcm2v1t = 4;

				form.fbagen.value += "		for (int i = 0; i < 0x" + toHex(pcm2vtot) + " / 2; i += " + pcm2v1t + " / 2) {\n";
				form.fbagen.value += "			unsigned short buffer[" + pcm2v1t + " / 2];\n";
				form.fbagen.value += "			memcpy(buffer, ((unsigned short*)YM2610ADPCMAROM) + i, " + pcm2v1t + ")\n";
				form.fbagen.value += "			for (int j = 0; j < " + pcm2v1t + " / 2; j++) {\n";
				form.fbagen.value += "				((unsigned short*)YM2610ADPCMAROM)[i + j] = buffer[j ^ " + (pcm2v1t/4) + "];\n";
				form.fbagen.value += "			}\n		}\n";
			}

			form.fbagen.value +="	}\n\n	return nRet;\n}\n";
		}
	}

// Driver info Output

	form.fbagen.value +="\nstruct BurnDriver BurnDrv" + form.setname.value + " = {\n";

	var parentname = "NULL";
	if ((form.parentname.value) && (form.bdfclone.value)) parentname = "\"" + form.parentname.value + "\"";

	var year = "NULL";
	if ((form.yearname.value) && (form.yearname.value != "NULL")) year = "\"" + form.yearname.value + "\"";

	var notes = "NULL";
	if ((form.notesname.value)&&(form.notesname.value != l_noneop))
		notes ="\"" + form.notesname.value + "\"";

	var developer = "NULL";
	if (form.devname.value) developer = "\"" + form.devname.value + "\"";

	if (fba_version == "old")
	{
		form.fbagen.value +="\n	{\"" + form.setname.value + "\", \"" + form.realname.value + "\", ";
		form.fbagen.value += notes + ", " + developer + ", \"Neo Geo\", " + year + ", ";
		form.fbagen.value +=parentname + ", \"neogeo\"},\n";
	}

	if (fba_version == "new")
	{
		form.fbagen.value += "	\"" + form.setname.value + "\", " + parentname + ", \"neogeo\", " + year + ",\n";
		form.fbagen.value += "	\"" + form.realname.value + "\\0\", " + notes + ", " + developer + ", \"Neo Geo\",\n";

		var unicode_name = "NULL";
		if ((form.non_latin_text.value)&&(form.non_latin_text.value != "null")) {
			var unicode_name = "L\"" + form.non_latin_text.value + "\\0\"";
		}

		form.fbagen.value += "	" + unicode_name + ", NULL, NULL, NULL,\n";
	}

	var BDF_INFO = 0;

	if (form.works.checked)	BDF_INFO = "BDF_GAME_WORKING";

	if (form.proto.checked)	{
		if (BDF_INFO) {
			BDF_INFO += " | BDF_PROTOTYPE";
		} else {
			BDF_INFO =  "BDF_PROTOTYPE";
		}
	}

	if (form.bootleg.checked) {
		if (BDF_INFO) {
			BDF_INFO += " | BDF_BOOTLEG";
		} else { 
			BDF_INFO = "BDF_BOOTLEG";
		}
	}

	if ((form.parentname.value) && (form.bdfclone.value)) {
		if (BDF_INFO) {
			BDF_INFO += " | BDF_CLONE";
		} else {
			BDF_INFO = "BDF_CLONE";
		}
	}

	form.fbagen.value += "	" + BDF_INFO;

	form.fbagen.value+=", 2, HARDWARE_SNK_NEOGEO"; // number of players & system

	if ((form.GfxKey.value) && (form.criptsel.value)) {
		form.fbagen.value += " | HARDWARE_SNK_ENCRYPTED_";
		if (form.criptsel.value == 1) form.fbagen.value += "A";
		if (form.criptsel.value == 2) form.fbagen.value += "B";
	}

	if (form.swapc.checked)  form.fbagen.value += " | HARDWARE_SNK_SWAPC";
	if (form.swapp.checked)  form.fbagen.value += " | HARDWARE_SNK_SWAPP";
	if (form.sram.checked)   form.fbagen.value += " | HARDWARE_SNK_SRAM";
	if (form.alttxt.checked) form.fbagen.value += " | HARDWARE_SNK_ALTERNATE_TEXT";

	if (form.controls.value != "neogeo")
		form.fbagen.value += " | HARDWARE_SNK_" + form.controls.value.slice(3, form.controls.value.length).toUpperCase();

	if (form.gambling.checked) form.fbagen.value +=" | HARDWARE_SNK_GAMBLING";

	form.fbagen.value +=",\n	NULL, " + form.setname.value + "RomInfo, " + form.setname.value + "RomName, " + form.controls.value + "InputInfo, " + form.controls.value + "DIPInfo,\n";

	if (show_fba_init) {
		form.fbagen.value += "	" + form.setname.value + "Init";
	} else {
		form.fbagen.value += "	NeoInit";
	}

	form.fbagen.value +=", NeoExit, NeoFrame, NeoRender, NeoScan, &NeoRecalcPalette,\n";

	var screenwidth  = "nNeoScreenWidth";
	var screenheight = "224";
	var screenratio  = "4, 3";

	form.fbagen.value +="	" + screenwidth + ", " + screenheight + ", " + screenratio + "\n};\n";
}














if (form.picker.value == "nebula")
{

	form.fbagen.value ="%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n\n";

// Header Output

	form.fbagen.value +="System: NEO\n";			// The system being emulated-  Always "NEO" (Neo-Geo)
	form.fbagen.value +="RomName: " + form.setname.value;	// The rom's name (ZIP) (Example: kof2000)
	form.fbagen.value +="\nGame: " + form.realname.value;	// The game's name (Example: King of Fighters)

	if (form.bootleg.checked)	form.fbagen.value += " (Bootleg)"

	if (form.proto.checked)		form.fbagen.value += " (Prototype)"

	form.fbagen.value +="\n"

	if ((form.bdfclone.value) && (form.parentname.value))
		form.fbagen.value +="Parent: " + form.parentname.value + "\n"; // The parent rom (if there is one)

// Px Output

	form.fbagen.value +="\n[Program]\n";

	for (i = 1; i < 4; i++)
	{
		var offset = 0;
		if (form["chxbxp" + i].checked)
		{
			if ((form.swapp.checked)&&(i == 1)) offset = 100000;
			if (i >= 2) offset = getlen("p", 1, i-1, 1);

			var pxcrc = PxInfo[i-1][2];
			if (pxcrc.length < 7) pxcrc = "0";

			form.fbagen.value += PxInfo[i-1][0] + "," + offset + "," + PxInfo[i-1][1] + "," + pxcrc + ",";
			if ((form.swapp.checked)&&(i == 1))
				form.fbagen.value += 1;
			else 
				form.fbagen.value += 0;

			form.fbagen.value += "\n";
		}
	}

// S1 Output

	form.fbagen.value +="\n[Text]\n"

	if (form.chxbxs1.checked)
	{
		var s1crc = S1Info[2];
		if (s1crc.length < 7) s1crc = "0";

		form.fbagen.value += S1Info[0] + "," + 0 + "," + S1Info[1] + "," + s1crc + ",0\n";
	}

// M1/M1D Output

	form.fbagen.value +="\n[Z80]\n"

	if (form.chxbxm1.checked)
	{
		var m1crc = M1Info[2];
		if (m1crc.length < 7) m1crc = "0";

		form.fbagen.value += M1Info[0] + ",0," + M1Info[1] + "," + m1crc +  ",0\n";
	}

	if (form.chxbxm1d.checked)
	{
		var m1dcrc = M1dInfo[2];
		if (m1dcrc.length < 7) m1dcrc = "0";

		form.fbagen.value += M1dInfo[0] + ",0," + M1dInfo[1] + "," + m1dcrc +  ",0\n";
	}

// Vx Output

	form.fbagen.value +="\n[Samples]\n"

	for (var i = 1; i < 6; i++)
	{
		if (form["chxbxv" + i].checked)
		{
			var v_crc = VxInfo[i-1][2];
			if (v_crc.length < 7) v_crc = "0";

			var offset = 0;
			if (getlen("v", 1, i-1, 1) != "00") offset = getlen("v", 1, i-1, 1);

			form.fbagen.value += VxInfo[i-1][0] + "," + offset + "," + VxInfo[i-1][1] + "," + v_crc +  ",0\n";
		}
	}

// Cx Output

	var c1swap = 0;
	var c2swap = 0;
	var swpval1 = "";
	var swpval2 = "";

	if (form.swapc.checked)
	{
		C2total = getlen("c", 1, 1, 1);
		c3total = getlen("c", 1, 1, 3);

		if ((CxInfo[0][1] == "200000") && (CxInfo[1][1] == "200000")) c1swap = "2";
		if ((CxInfo[2][1] == "200000") && (CxInfo[3][1] == "200000")) c2swap = "2";
		
		if ((CxInfo[2][1] == "80000") && (form.chxbxc3.checked)) swpval1 = ",400000,200000,0,0\n"; // type 1

		if ((!c2swap)&&(c1swap)) swpval1 = ",400000,100000,0,0\n"; // type 2

		if (c2swap) { // type 3
			swpval2 = ",400000,200000,0,0\n";
			if (form.setname.value.toLowerCase() == "3countb") {
				swpval1 = swpval2;
				swpval2 = ",600000,200000,0,0\n";
			}
		}
	}

	form.fbagen.value +="\n[Graphics]\n";

	for (var i = 1; i < 9; i++)
	{
		if (form["chxbxc" + i].checked)
		{
			var swap = 0;
			if (i<3) swap = c1swap;
			if ((i>2)&&(i<5)) swap = c2swap;
			var c_crc = CxInfo[i-1][2];
			if (c_crc.length < 7) c_crc = "0";

			var offset = getlen("c", 1, ((i-1)&14), (3^((i&1)<<1)));
			if (offset.length <= 2) offset &= 1;
			if ((i == 2) && (form.c1size.value == "33554432")) offset = CxInfo[0][1]; // SVCCHAOS Cx Fix

			form.fbagen.value += CxInfo[i-1][0] + "," + offset + "," + CxInfo[i-1][1] + "," + c_crc +  "," + swap + "\n";
		}

		if ((swpval1) && (i == 2)) form.fbagen.value += swpval1;
		if ((swpval2) && (i == 8)) form.fbagen.value += swpval2;
	}

// Footer Output

	var criptsel = "0";
	var gfxkey = "0";

	if ((form.GfxKey.value) && (form.criptsel.value)) {
		criptsel = form.criptsel.value;
		gfxkey = form.GfxKey.value;
	}

	form.fbagen.value +="\n[System]\n"

 	// This is the Unique Id. number for each game. You can find it at offset 0x108 of most P roms.
	form.fbagen.value +="CartridgeID: ";
	form.fbagen.value +=form.cartidn.value;

	form.fbagen.value +="\nGfxCrypt: " + criptsel + "\n";
	form.fbagen.value +="GfxKey: " + gfxkey + "\n";

	if ((form.pcm2.value != "00") && (form.pcm2.value != "03")) {
		var nebpcm2val = 0;
		if (form.pcm2.value < 3) nebpcm2val = form.pcm2.value;
		if (form.pcm2.value > 2) nebpcm2val = "0" + eval(form.pcm2.value-8);
		if ((nebpcm2val&14)==6) nebpcm2val = "0" + (nebpcm2val^1); // swap samsho5 & svc
		form.fbagen.value += "PCM2: " + nebpcm2val + "\n";
	}

	//  This section is to deal with JockeyGP and Vliner's butlayout numbers.
	//  While all other neogeo games are 9, Jockeygp is 7 and Vliner is 8

	var butlayout = "9";
	if (form.gambling.checked) {
		var find_name_letter = form.setname.value.slice(0,1);
		if (find_name_letter.toLowerCase() == "j") butlayout = 7; // jockeygp
		if (find_name_letter.toLowerCase() == "v") butlayout = 8; // vliner
	}

	form.fbagen.value +="ButLayout: " + butlayout + "\n"; 
	form.fbagen.value +="Fix: ";

	if (form.nebfixn.value)
	{
		form.fbagen.value +=form.nebfixn.value;
	} else {
		form.fbagen.value +="0";
	}

	form.fbagen.value +="\n\n%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%";
}










if (form.picker.value == "mame")
{
	var mamebios="neogeo,";
	var gameb="B";
	var criptsel = "";

	if (form.GfxKey.value) {
		if (form.chxbxs1.checked) {
			if (form.criptsel.value == 1) criptsel = "	cmc42";
			if (form.criptsel.value == 2) criptsel = "	cmc50";
		} else {
			if (form.criptsel.value == 1) criptsel = "	kof99"
			if (form.criptsel.value == 2) criptsel = "	kof2000";
		}

		if (criptsel) criptsel += "_neogeo_gfx_decrypt(0x" + form.GfxKey.value + ");\n";
	}

	form.fbagen.value = l_mmtxt5 + "\n\n";
	form.fbagen.value +="ROM_START( " + form.setname.value + " )\n";

	var crc1val="CRC(";
	var crc2val=")";

// Px Output

	var ptotal=getlen("p", 1, 3, 1);

	if ((form.gambling.checked) && (!form.chxbxp2.checked) && (PxInfo[0][1] == "100000"))
		ptotal = "200000";

	form.fbagen.value +="	ROM_REGION( 0x" + ptotal + ", REGION_CPU1, 0 )\n";

	for (i = 1; i < 4; i++)
	{
		if (form["chxbxp" + i].checked)
		{
			var px_crc =  mame_crc(PxInfo[i-1][2], crc1val, crc2val, 7);
			var px_size = PxInfo[i-1][1];
			var offset = mame_offset(ptotal, getlen("p", 1, i-1, 1));
			if ((form.swapp.checked) && (i==1)) { // Swap P
				offset = "100000";
				px_size = offset;
			}

			form.fbagen.value +="	ROM_LOAD16_WORD_SWAP( \"" + PxInfo[i-1][0] + "\", 0x" + offset + ", 0x" + PxInfo[i-1][1] + ", " + px_crc + PxInfo[i-1][3] + " )\n";
		}
	}

	if ((form.gambling.checked) && (!form.chxbxp2.checked) && (PxInfo[0][1] == "100000"))
		form.fbagen.value += "	ROM_FILL( 				     0x100000, 0x100000, 0xFF )\n";

	if (form.swapp.checked)
		form.fbagen.value +="	ROM_CONTINUE(					   0x000000, 0x100000 )\n"

	form.fbagen.value +="\n";

// S1 Output

	var s_rom_written = 0;
	var s1crc = mame_crc(S1Info[2], crc1val, crc2val, 7);

	if ((form.chxbxs1.checked) && (eval(form.s1size.value / 1024) < 256))
	{
		var ssize = eval(form.s1size.value / 1024);

		if (form.s1size.value <= 131072)
		{
			form.fbagen.value +="	NEO_SFIX_" + ssize + "K( \"" + S1Info[0] + "\", " + s1crc + S1Info[3] + " )\n\n";
			s_rom_written = 1;
		}
	}

	if (s_rom_written != 1)
	{
		var s1esha1 = "";
		var s1size4mame = S1Info[1];
		var snotesmame = "";
		if (!form.chxbxs1.checked) s1size4mame = "20000";
		if (form.textromfix.checked) s1size4mame = "80000";
		if ((form.textromfix.checked)||((form.chxbxs1.checked)&&(form.s1size.value < 262144))) snotesmame = " /* larger char set */ "

		if (!form.chxbxs1.checked)
			form.fbagen.value +="	/* The Encrypted Boards do _not_ have an s1 rom, data for it comes from the Cx ROMs */\n"

		form.fbagen.value +="	ROM_REGION( 0x" + s1size4mame + ", REGION_GFX1, 0 )" + snotesmame + "\n"

		if (form.chxbxs1.checked)
			form.fbagen.value += "	ROM_LOAD( \"" + S1Info[0] + "\",		0x000000, 0x" + S1Info[1] + ", " + s1crc + S1Info[3] + " )\n";
		else
			form.fbagen.value +="	ROM_FILL(                 0x000000, 0x" + s1size4mame + ", 0 )\n"

		form.fbagen.value +="	ROM_REGION( 0x20000, REGION_GFX2, 0 )\n"

		if (form.usesha.value == 1) s1esha1 = " SHA1(" + sfixsha + ")";

		form.fbagen.value +="	ROM_LOAD( \"sfix.sfx\",  0x000000, 0x20000, " + crc1val + sfixcrc + crc2val + s1esha1 + " )\n\n"
	}

// M1/M1D Output

	if (form.chxbxm1.checked)
	{
		var m1crc = mame_crc(M1Info[2],    crc1val, crc2val, 7);
		form.fbagen.value += "	ROM_REGION( 0x" + M1Info[1] + ", REGION_USER4, 0 )\n";
		form.fbagen.value += "	\/* The M1 ROM is encrypted, we load it here for reference and replace it with a decrypted version *\/\n";
		form.fbagen.value += "	ROM_LOAD( \"" + M1Info[0] + "\", 0x00000, 0x" + M1Info[1] + ", " + m1crc + M1Info[3] + " )\n";
		form.fbagen.value += "	/* Decrypted */\n";
	}

	if (form.chxbxm1d.checked)
	{
		var m1dcrc = mame_crc(M1dInfo[2],  crc1val, crc2val, 7);
		form.fbagen.value +="	NEO_BIOS_SOUND_" + eval(form.m1dsize.value / 1024) + "K( \"" + M1dInfo[0] + "\", " + m1dcrc + M1dInfo[3] + " )\n\n";
	}

// Vx Output

	var b_reg2 = 5;
	var vx1total = 0;
	var vx2total = 0;

	for (var i = 1; i < 6; i++) { // find sound region 2
		if (form["chxbxv" + i].checked)	{
			var tmp = VxInfo[i-1][0];
			for (var j = 0; j < 16; j++) {
				var tmp2 = tmp.slice(j, j+3);
				if ((tmp2.toLowerCase() == "v21")||(tmp2.toLowerCase() == "v22")||(tmp2.toLowerCase() == "v23")||(tmp2.toLowerCase() == "v24")) {
					b_reg2 = i-1;
					i = 6;
				}
			}
		}
	}

	if (getlen("v", 1, b_reg2, 1) == 0)
		vx1total = "200000";
	else
		vx1total = getlen("v", 1, b_reg2, 1);

	if (b_reg2) vx2total = getlen("v", b_reg2+1, 5, 1);

	form.fbagen.value +="	ROM_REGION( 0x" + vx1total + ", REGION_SOUND1, 0 )\n";

	if (form.pcm2.value != "00") form.fbagen.value += "\t/* Encrypted */\n";

	for (var i = 1; i < 6; i++)
	{
		if (form["chxbxv" + i].checked)
		{
			var vx_crc = mame_crc(VxInfo[i-1][2], crc1val, crc2val, 7);
			var offset = mame_offset(vx1total, getlen("v", 1, i-1, 1));
			if (i > b_reg2) offset = mame_offset(vx2total, getlen("v", b_reg2+1, i-1, 1));
			if (i == b_reg2+1) form.fbagen.value +="\n	ROM_REGION( 0x" + vx2total + ", REGION_SOUND2, 0 )\n";
			form.fbagen.value +="	ROM_LOAD( \"" + VxInfo[i-1][0] + "\", 0x" + offset + ", 0x" + VxInfo[i-1][1] + ", " + vx_crc + VxInfo[i-1][3] + " )\n";
		} else {
			i = 6;
		}
	}

	if (b_reg2 == 5) form.fbagen.value +="	\n	NO_DELTAT_REGION\n";

// Cx Output

	var C2total = getlen("c", 1, 2, 1);
	var C3total = getlen("c", 1, 2, 3);
	var Ctotal  = getlen("c", 1, 8, 1);
	var enswapc = 0;

	if ((!form.chxbxc5.checked) && (CxInfo[0][1] == "200000") && (form.swapc.checked))
	{
		CxInfo[0][1] = "100000";
		CxInfo[1][1] = "100000";

		if (CxInfo[2][1] == "200000") CxInfo[2][1] = "100000";
		if (CxInfo[3][1] == "200000") CxInfo[3][1] = "100000";

		if ((form.chxbxc3.checked) && (form.chxbxc4.checked)) Ctotal="600000";

		C2total = "200000";
		C3total = "200001";

		enswapc = "1";
	}

	form.fbagen.value +="\n	ROM_REGION( 0x" + Ctotal + ", REGION_GFX3, 0 )\n";

	if (criptsel) form.fbagen.value += "\t/* Encrypted */\n";

	for (i = 1; i < 9; i++)
	{
		if (form["chxbxc" + i].checked)
		{
			var cx_crc = mame_crc(CxInfo[i-1][2], crc1val, crc2val, 7);
			var offset = "000000";
			if (Ctotal.length == 7) offset += "0";
			if (i == 2){
				offset = offset.slice(0, offset.length-1) + 1;
				if (form.c1size.value&0x2000000) offset = CxInfo[0][1];
			}
			if (i == 3) offset = C2total;
			if (i == 4) offset = C3total;
			if (i > 4)  offset = getlen("c", 1, ((i-1)&14), (3^((i&1)<<1)));

			form.fbagen.value += "	ROM_LOAD16_BYTE( \"" + CxInfo[i-1][0] + "\", 0x" + offset + ", 0x" + CxInfo[i-1][1] + ", " + cx_crc + CxInfo[i-1][3] + " ) ";

			form.fbagen.value += "/* Plane " + (((i&1)^1)<<1) + "," + ((((i&1)^1)<<1)+1) + " */\n";

			if ((form["c" + i + "size"].value == "2097152") && (enswapc))
				form.fbagen.value += "	ROM_CONTINUE(      			   0x" + (4+((i-1)&2)) + "0000" + (~i&1) + ", 0x100000 )\n"
		}
	}

// Init Output

	form.fbagen.value += "ROM_END";

	var show_mame_init = 0;
	var encryption_stuff = "";
	var fix_bank = "";
	var extract_sdata = "";
	var pcm2_stuff = "";

	if (form.pcm2.value != "00") {

		show_mame_init = 1;

		if (form.pcm2.value > 10) pcm2_stuff = "\n	neo_pcm2_swap(" + (form.pcm2.value-11) + ");\n";
		if (form.pcm2.value < 10)
		{
			var outval = form.pcm2.value<<3;
			if (form.pcm2.value == 3) outval = 4;

			pcm2_stuff = "\n	/* Thanks to Elsemi for the NEO-PCM2 info */\n	neo_pcm2_snk_1999(" + outval + ");\n";
		}
	}

	if (criptsel) {
		show_mame_init = 1;
		fix_bank = "	neogeo_fix_bank_type = 1;\n"
		encryption_stuff = criptsel;
	}

	if (form.alttxt.checked) {
		show_mame_init = 1;
		fix_bank = "	neogeo_fix_bank_type = 2;\n"
	}

	if ((!form.criptsel.value) && (!form.chxbxs1.checked))
	{
		show_mame_init = 1;

		extract_sdata =  "	/* the S data comes from the end fo the C data */\n";
		extract_sdata += "	int i;\n	UINT8 *src = memory_region(REGION_GFX3) + memory_region_length(REGION_GFX3) - 0x" + s1size4mame + ";\n";
		extract_sdata += "	UINT8 *dst = memory_region(REGION_GFX1);\n\n	for (i = 0; i < 0x" + s1size4mame + "; i++)\n";
		extract_sdata += "		dst[i] = src[(i & 0x1ffe0) + ((i & 7) << 2) + ((~i & 8) >> 2) + ((i & 0x10) >> 4)];\n\n";
	}

	if (show_mame_init)
	{
  		form.fbagen.value +="\n\n\n" + l_mmtxt2 + " \n\n";

		form.fbagen.value +="DRIVER_INIT( " + form.setname.value + " )\n{\n";

		form.fbagen.value += extract_sdata;
		form.fbagen.value += fix_bank;
		form.fbagen.value += encryption_stuff;

		form.fbagen.value +="	init_neogeo();\n";

		form.fbagen.value += pcm2_stuff;

		form.fbagen.value += "}";
	}

// End Output

	form.fbagen.value +="\n\n\n" + l_mmtxt1 + " NEOGEO.C (src/drivers/)\n\n";

	var parentname ="neogeo";

	if ((form.bdfclone.value) && (form.parentname.value))
	{
		var parentname = form.parentname.value;
	}

	var initname = "neogeo";

	if (show_mame_init) var initname = form.setname.value;

	// mjneogeo irrmaze -->trackball

	var controls = "neogeo";
	if (form.controls.value == "neotrackball")
		controls = "irrmaze";
	if (form.controls.value == "neomahjong")
		controls = "mjneogeo";
	if (form.controls.value == "neopaddle")
		controls = "neogeo";

	var working = "X";
	var working2 = ", GAME_NOT_WORKING";
	if (form.works.checked) {
		working = "";
		working2 = ", 0";
	}

	var prototype = "";
	if (form.proto.checked)
		prototype = " (Prototype)";

	var bootleg = "";
	if (form.bootleg.checked)
		bootleg = " (Bootleg)";

	form.fbagen.value +="GAME" + gameb + working + "( " + form.yearname.value + ", " + form.setname.value + ", " + parentname + ", " + mamebios + " neogeo, " + controls + ",  " + initname + ",   ROT0, \"" + form.devname.value + "\", \"" + form.realname.value + prototype + bootleg + "\"" + working2 + " )";

	if ((form.criptsel.value) && (form.GfxKey.value))
	{
		form.fbagen.value += "	/* Encrypted GFX */";
	}


	form.fbagen.value +="\n\n\n" + l_mmtxt1 + " DRIVER.C (src/)\n\n";

	var cartidmame = ""
	if (form.cartidn.value)
		var cartidmame = form.cartidn.value + " ";

	form.fbagen.value +="	DRIVER( " + form.setname.value + " )	/* " + cartidmame + "(c) " + form.yearname.value + " " + form.devname.value + " */";

}

// Leave these alone!!!!!
   }
}